From cf8b15829ff3a2a9ff4a8644aec1fabe38c035ff Mon Sep 17 00:00:00 2001
From: Francois-Rene Rideau <tunes@google.com>
Date: Fri, 29 Mar 2013 22:36:49 -0400
Subject: [PATCH] Clozure CL: When waiting for multiple inputs, don't error out
 because some are closed.

---
 backend/openmcl.lisp | 19 ++++++++++---------
 1 file changed, 10 insertions(+), 9 deletions(-)

diff --git a/backend/openmcl.lisp b/backend/openmcl.lisp
index 4d99053..5f21df1 100644
--- a/backend/openmcl.lisp
+++ b/backend/openmcl.lisp
@@ -42,16 +42,17 @@
       (let ((max-fd -1))
         (dolist (sock sockets)
           (let ((fd (openmcl-socket:socket-os-fd (socket sock))))
-            (setf max-fd (max max-fd fd))
-            (ccl::fd-set fd infds)))
-        (let* ((res (#_select (1+ max-fd)
-                              infds (ccl::%null-ptr) (ccl::%null-ptr)
-                              (if ticks-to-wait tv (ccl::%null-ptr)))))
+            (when fd ;; may be NIL if closed
+              (setf max-fd (max max-fd fd))
+              (ccl::fd-set fd infds))))
+        (let ((res (#_select (1+ max-fd)
+                             infds (ccl::%null-ptr) (ccl::%null-ptr)
+                             (if ticks-to-wait tv (ccl::%null-ptr)))))
           (when (> res 0)
-            (dolist (x sockets)
-              (when (ccl::fd-is-set (openmcl-socket:socket-os-fd (socket x))
-                                    infds)
-                (setf (state x) :READ))))
+            (dolist (sock sockets)
+              (let ((fd (openmcl-socket:socket-os-fd (socket sock))))
+                (when (and fd (ccl::fd-is-set fd infds))
+                  (setf (state sock) :READ)))))
           sockets)))))
 
 (defun raise-error-from-id (condition-id socket real-condition)
-- 
1.8.1.3

